"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _axios = _interopRequireDefault(require("axios"));

var _lodash = require("lodash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var Runtime = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(url, method) {
    var options,
        config,
        DEV,
        TAG,
        baseUrl,
        headers,
        params,
        data,
        baseUrlNil,
        message,
        requestUrlNil,
        _message,
        instance,
        disableRequestInterceptor,
        requestInterceptor,
        disableResponseInterceptor,
        responseInterceptor,
        res,
        successHandler,
        errorObject,
        errorHandler,
        isCanceled,
        finallyHandler,
        _args = arguments;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            options = _args.length > 2 && _args[2] !== undefined ? _args[2] : {
              // handlers
              successHandler: undefined,
              errorHandler: undefined,
              finallyHandler: undefined,
              disableRequestInterceptor: false,
              disableResponseInterceptor: false,
              // i.o interceptors
              requestInterceptor: {
                onFulfilled: function onFulfilled() {},
                onRejected: function onRejected() {}
              },
              responseInterceptor: {
                onFulfilled: function onFulfilled() {},
                onRejected: function onRejected() {}
              },
              //  axios canceler
              cancelToken: undefined
            };
            config = _args.length > 3 && _args[3] !== undefined ? _args[3] : {
              timeout: 15 * 1000,
              baseURL: undefined,
              params: {},
              // query params
              data: undefined,
              // body data
              headers: {
                'Content-Type': 'application/json',
                Authorization: undefined
              }
            };
            DEV = _args.length > 4 && _args[4] !== undefined ? _args[4] : false;
            TAG = "[!][".concat(method.toUpperCase(), "][").concat(url, "](").concat(new Date().getTime(), ")");
            _context.prev = 4;

            if (DEV && console.time) {
              console.time(TAG);
            }

            console.groupCollapsed(TAG);
            baseUrl = (0, _lodash.get)(config, 'baseURL');
            headers = _objectSpread({
              'Content-Type': 'application/json'
            }, (0, _lodash.get)(config, 'headers', {}));
            params = (0, _lodash.get)(config, 'params', {});
            data = (0, _lodash.get)(config, 'data');
            console.log('request-headers=>', headers);
            console.log('url-params=>', params);
            console.log('body-data=>', data); // Ensure there's no undefined

            baseUrlNil = (0, _lodash.isNil)(baseUrl) || baseUrl.includes('undefined') || baseUrl.includes('null');

            if (!baseUrlNil) {
              _context.next = 19;
              break;
            }

            message = "API Base Url contains \"null\" or \"undefined\". Check input: \"".concat(baseUrl, "\".");
            console.error(message); // eslint-disable-next-line no-alert

            return _context.abrupt("return", DEV && alert && alert(message));

          case 19:
            requestUrlNil = (0, _lodash.isNil)(url) || url.includes('undefined') || url.includes('null');

            if (!requestUrlNil) {
              _context.next = 24;
              break;
            }

            _message = "API Request Url contains \"null\" or \"undefined\". Check input: \"".concat(url, "\".");
            console.error(_message); // eslint-disable-next-line no-alert

            return _context.abrupt("return", DEV && alert && alert(_message));

          case 24:
            if (!global.canceler || global.canceler.token.reason) {
              console.debug('request canceler=>', global.canceler);
              global.canceler = _axios["default"].CancelToken.source();
            } // Create an axios instance


            instance = _axios["default"].create(_objectSpread(_objectSpread({}, config), {}, {
              baseURL: config.baseURL,
              timeout: config.timeout,
              headers: _objectSpread({
                // Default accept header set to json
                'Content-Type': 'application/json',
                'Accept-Language': (0, _lodash.get)(config, 'headers.acceptLanguage')
              }, (0, _lodash.get)(config, 'headers', {})),
              cancelToken: (0, _lodash.get)(options, 'cancelToken') || (0, _lodash.get)(global, 'canceler.token')
            }));
            disableRequestInterceptor = (0, _lodash.get)(options, 'disableRequestInterceptor');
            requestInterceptor = (0, _lodash.get)(options, 'requestInterceptor');

            if (_typeof(requestInterceptor) === 'object' && !disableRequestInterceptor) {
              instance.interceptors.request.use(requestInterceptor.onFulfilled, requestInterceptor.onRejected);
            }

            disableResponseInterceptor = (0, _lodash.get)(options, 'disableResponseInterceptor');
            responseInterceptor = (0, _lodash.get)(options, 'responseInterceptor');

            if (_typeof(responseInterceptor) === 'object' && !disableResponseInterceptor) {
              instance.interceptors.response.use(responseInterceptor.onFulfilled(global.canceler), responseInterceptor.onRejected(global.canceler));
            }

            if (!['patch', 'post', 'put'].includes(method)) {
              _context.next = 38;
              break;
            }

            _context.next = 35;
            return instance[method](url, data, {
              params: params
            });

          case 35:
            _context.t0 = _context.sent;
            _context.next = 41;
            break;

          case 38:
            _context.next = 40;
            return instance[method](url, {
              params: params,
              data: data
            });

          case 40:
            _context.t0 = _context.sent;

          case 41:
            res = _context.t0;
            successHandler = (0, _lodash.get)(options, 'successHandler');

            if (!(typeof successHandler === 'function')) {
              _context.next = 46;
              break;
            }

            _context.next = 46;
            return successHandler(res);

          case 46:
            return _context.abrupt("return", res);

          case 49:
            _context.prev = 49;
            _context.t1 = _context["catch"](4);
            // if error has normal response, use default handling
            // if custom handler is gave, use it
            errorObject = _context.t1;

            if (_context.t1.response) {
              errorObject = _context.t1.response;
            }

            errorHandler = (0, _lodash.get)(options, 'errorHandler');

            if (!(typeof errorHandler === 'function')) {
              _context.next = 58;
              break;
            }

            isCanceled = _axios["default"].isCancel(_context.t1);
            _context.next = 58;
            return errorHandler(errorObject, isCanceled, global.canceler);

          case 58:
            throw errorObject;

          case 59:
            _context.prev = 59;
            finallyHandler = (0, _lodash.get)(options, 'finallyHandler');

            if (!(typeof finallyHandler === 'function')) {
              _context.next = 64;
              break;
            }

            _context.next = 64;
            return finallyHandler();

          case 64:
            console.groupEnd();

            if (DEV && console.timeEnd) {
              console.timeEnd(TAG);
            }

            return _context.finish(59);

          case 67:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[4, 49, 59, 67]]);
  }));

  return function Runtime(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _default = Runtime;
exports["default"] = _default;