"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _reactNative = require("react-native");

var _default = function _default() {
  var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    btnOk: 'OK',
    btnMore: 'More',
    title: 'API Request Failure',
    desc: 'The action is failure.'
  };
  return function (response, callback) {
    return _reactNative.Alert.alert(text.title, text.desc, [{
      text: text.btnOk,
      onPress: function onPress() {
        return callback && callback();
      },
      style: 'cancel'
    }, {
      text: text.btnMore,
      onPress: function onPress() {
        _reactNative.Alert.alert(text.btnMore, "Status Code: ".concat(response.status, "\nMessage: \"").concat((0, _lodash.get)(response, 'data.message') || (0, _lodash.get)(response, 'message'), "\""), [{
          text: text.btnOk,
          onPress: function onPress() {
            return callback && callback();
          },
          style: 'cancel'
        }]);
      }
    }], {
      cancelable: false
    });
  };
};

exports["default"] = _default;