"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _netinfo = _interopRequireDefault(require("@react-native-community/netinfo"));

var _reactNative = require("react-native");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var _default = function _default() {
  var text = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    btnOk: 'OK',
    btnMore: 'More',
    title: 'Server unavailable',
    desc: 'More'
  };
  return function (response, callback) {
    return _reactNative.Alert.alert(text.title, text.desc, [{
      text: text.btnOk,
      onPress: function onPress() {
        return callback && callback();
      },
      style: 'cancel'
    }, {
      text: text.btnMore,
      onPress: function () {
        var _onPress = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
          var networkState;
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return _netinfo["default"].fetch();

                case 2:
                  networkState = _context.sent;

                  _reactNative.Alert.alert(text.btnMore, "Is Connected: ".concat(networkState.isConnected, "\nInternet Reachable: ").concat(networkState.isInternetReachable, "\nDetails: ").concat(JSON.stringify(networkState.details)), [{
                    text: text.btnOk,
                    onPress: function onPress() {
                      if (typeof callback === 'function') callback(networkState);
                    },
                    style: 'cancel'
                  }]);

                case 4:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        function onPress() {
          return _onPress.apply(this, arguments);
        }

        return onPress;
      }()
    }], {
      cancelable: false
    });
  };
};

exports["default"] = _default;