"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = exports.onApiFetchFailure = exports.onApiFetchSuccess = exports.onApiFetching = void 0;

var _reduxsauce = require("reduxsauce");

var _Actions = require("./Actions");

var _InitialState = require("./InitialState");

var _createReducer;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var onApiFetching = function onApiFetching(state, _ref) {
  var config = _ref.config,
      method = _ref.method,
      url = _ref.url,
      options = _ref.options;
  return _objectSpread(_objectSpread({}, state), {}, {
    request: config,
    response: null,
    error: null,
    isFetching: true
  });
};

exports.onApiFetching = onApiFetching;

var onApiFetchSuccess = function onApiFetchSuccess(state, _ref2) {
  var data = _ref2.data;
  return _objectSpread(_objectSpread({}, state), {}, {
    response: data,
    error: null,
    isFetching: false
  });
};

exports.onApiFetchSuccess = onApiFetchSuccess;

var onApiFetchFailure = function onApiFetchFailure(state, _ref3) {
  var error = _ref3.error;
  return _objectSpread(_objectSpread({}, state), {}, {
    error: error,
    response: null,
    isFetching: false
  });
};
/**
 * @see https://github.com/infinitered/reduxsauce#createreducer
 */


exports.onApiFetchFailure = onApiFetchFailure;
var reducer = (0, _reduxsauce.createReducer)(_InitialState.INITIAL_STATE, (_createReducer = {}, _defineProperty(_createReducer, _Actions.AppApiTypes.ON_API_FETCHING, onApiFetching), _defineProperty(_createReducer, _Actions.AppApiTypes.ON_API_FETCH_SUCCESS, onApiFetchSuccess), _defineProperty(_createReducer, _Actions.AppApiTypes.ON_API_FETCH_FAILURE, onApiFetchFailure), _createReducer));
exports.reducer = reducer;