"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _redux = require("redux");

var _Reducers = _interopRequireDefault(require("./Reducers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Add middleware here
var middleware = []; // Debug tool integration;

var composeEnhancers = _redux.compose;

if (process.env.NODE_ENV === 'development') {
  // Use it if Remote debugging with RNDebugger, otherwise use remote-redux-devtools
  composeEnhancers = (window.__REDUX_DEVTOOLS_EXTENSION_COMPOSE__ || // eslint-disable-next-line global-require
  require('remote-redux-devtools').composeWithDevTools)({
    name: "ApiRuntime",
    trace: true,
    traceLimit: 10
  });
}

console.log('reducers=>', _Reducers["default"]); // Create the store

var store = (0, _redux.createStore)((0, _redux.combineReducers)(_Reducers["default"]), composeEnhancers(_redux.applyMiddleware.apply(void 0, middleware)));
console.log('store=>', store);
var _default = store;
exports["default"] = _default;